// Includes
#include <PA9.h>
#include "gfx/all_gfx.c"
#include "gfx/all_gfx.h"

void init();
int action();
void shoot(int angle);
void move_balles();
void verif_touches(int angle);
void new_ennemy();
void move_ennemy();
u8 verif_toucher(u8 i);
int collision(u8 ball, u8 ennemy_);
void touche_bonus();
void gestion_combo();
void unlock();
int aucun_ennemy();
void lacher_bonus(u8 j);
void nouvelle_vague();

struct bonus_{
                int posx;
                int posy;
                u8 used;
                u16 time;
                };
struct bonus_ bonuss[5];

struct ennemy_{
                int posx;
                int posy;
                int movx;
                int movy;
                s16 vie;
                u8 vitesse;
                u8 used;
                };
struct ennemy_ ennemy[15];

struct hero_{
                int posx;
                int posy;
                int movx;
                int movy;
                int vie;
                u8 vitesse;
                };
struct hero_ hero;

struct balles_{
                int posx;
                int posy;
                int movx;
                int movy;
                u8 used;
                u16 parcouru;
                };
struct balles_ balles[10];

struct arme_{
                u8 cooltime;
                int degats;
                int vitesse;
                s16 munitions;
                u8 muni_max;
                u8 range;
                };
struct arme_ arme[10];

char nom_armes[3][30]={"Pistolet","Uzi","Fusil  pompe"};
u8 cool;
u8 weapon;
u8 compteur;
u8 combo;
u16 time_combo;
u8 ennemy_time;
u8 debloque;
u16 chef;
u8 vague;
u8 limite;
s16 nb_ennemy;
u8 arme_ok;
int score=0;
// Main function
int main(void)	{

	PA_Init();
	PA_InitVBL();
    PA_InitRand();
    init();
	while(1)
	{
        action();//le jeu est une succession d'action
    	PA_WaitForVBL();
	}
	return 0;
}

void init(){//initialisation des sprites et compagnie
    PA_ResetSpriteSys();
    PA_ResetBgSys();
	PA_Init8bitBg(0, 1);
	PA_SetBgPalCol(0, 1, PA_RGB(31, 31, 31));//utiliser pour les traces des balles
	PA_SetBgPalCol(0, 2, PA_RGB(31, 0, 0));
	PA_SetBgPalCol(0, 3, PA_RGB(0, 0, 31));
	PA_SetBgPalCol(0, 4, PA_RGB(0, 31, 0));
    PA_InitText(1,1);
    PA_InitText(0,1);
	PA_LoadSpritePal(0, 0, (void*)all_Pal);	// Load the sprite palette
    u8 i;

    hero.posx=(128-8)<<8;
    hero.posy=(96-8)<<8;
    hero.vitesse=192;
	PA_CreateSprite(0, 10,(void*)heros_Sprite, OBJ_SIZE_16X16,1, 0, hero.posx>>8, hero.posy>>8);
    for(i=0;i<10;i++)
    {
        balles[i].posx=256<<8;
        balles[i].posy=192<<8;
        balles[i].used=0;
        PA_CreateSprite(0, i,(void*)balle_Sprite, OBJ_SIZE_8X8,1, 0,balles[i].posx>>8,balles[i].posx>>8);
    }
    for(i=20;i<30;i++)
    {
        ennemy[i-20].posx=256<<8;
        ennemy[i-20].posy=192<<8;
        ennemy[i-20].vitesse=112;
        ennemy[i-20].used=0;
        PA_CreateSprite(0, i,(void*)enemy_Sprite, OBJ_SIZE_16X16,1, 0,ennemy[i-20].posx>>8,ennemy[i-20].posx>>8);
        PA_SetSpriteRotEnable(0, i, (i-20)+1);
    }
    for(i=30;i<35;i++)
    {
        ennemy[i-20].posx=256<<8;
        ennemy[i-20].posy=192<<8;
        ennemy[i-20].vitesse=112;
        ennemy[i-20].used=0;
        PA_CreateSprite(0, i,(void*)boss_Sprite, OBJ_SIZE_16X16,1, 0,ennemy[i-20].posx>>8,ennemy[i-20].posx>>8);
        PA_SetSpriteRotEnable(0, i, (i-20)+1);
    }
    for(i=40;i<45;i++)
    {
        bonuss[i-40].used=0;
    	PA_CreateSprite(0, i,(void*)bonus_Sprite, OBJ_SIZE_16X16,1, 0, 256, 192);
    }
    PA_SetSpriteRotEnable(0, 10, 0);
    arme[0].cooltime=40;
    arme[0].vitesse=30*256;
    arme[0].muni_max=-1;
    arme[0].munitions=-1;
    arme[0].range=60;
    arme[0].degats=20;
    arme[1].cooltime=10;
    arme[1].vitesse=30*256;
    arme[1].muni_max=100;
    arme[1].munitions=0;
    arme[1].range=50;
    arme[1].degats=10;
    arme[2].cooltime=60;
    arme[2].vitesse=30*256;
    arme[2].muni_max=20;
    arme[2].munitions=0;
    arme[2].range=30;
    arme[2].degats=25;
    cool=60;
    weapon=0;
    compteur=0;
    combo=0;
    time_combo=0;
    ennemy_time=240;
    debloque=0;
    chef=900;
    vague=0;
    limite=0;
    nb_ennemy=0;
    score=0;
    arme_ok=1;
    //PA_InitAllSpriteDraw();
    PA_WaitFor(Stylus.Newpress);
    PA_OutputText(1,1,23,nom_armes[weapon]);
}

int action(){//coeur du jeu
    u16 angle = PA_GetAngle((hero.posx>>8)+4,(hero.posy>>8)+5,Stylus.X,Stylus.Y);//angle de tir par rapport au stylet
    PA_SetRotsetNoZoom(0,0,angle);//rotation vers cet angle
    verif_touches(angle);//on vrifie les touches appuyes, on donne l'angle pour savoir o tirer le cas chant
    move_balles();//on bouge les projectiles
    move_ennemy();//on bouge les ennemis
    touche_bonus();//on vrifie si on touche un bonus
    PA_SetSpriteXY(0,10,hero.posx>>8,hero.posy>>8);//on dplace le hros
    cool++;//temps entre 2 tirs pour ne tirer qu' intervalles rguliers imposes par l'arme
    compteur++;//compteur de temps entre l'apparition de deux ennemis
    chef--;//arrive du chef imminente ( 0)
    if(cool>=254) cool=254;//comme cool est un u8, on vrifie  ne pas dpasser 255
    if(((compteur>=ennemy_time)||chef==0)&&nb_ennemy<limite){//si il a moins d'ennemis que la limite de la vague
                                                            //et qu'on peut envoyer un ennemi (ou chef)
        compteur=0;
        new_ennemy();//nouvel ennemi
        if(chef==0) chef=900;//nouveau chef si besoin
        nb_ennemy++;
    }
    gestion_combo();//gestion du systeme de combos
    if(nb_ennemy==limite&&aucun_ennemy()) nouvelle_vague();//si on a combattu la limite d'ennemis de la vague
                                                        //et tout le monde mort : nouvelle vague
    return 1;
}

void shoot(int angle){//fonction de tir
    u8 i,j;
    s8 non_used=-1;
    if(weapon<=1){//si arme 0 ou 1 (pistolet, uzi)
        for(i=0;i<10;i++){//on cherche la premiere balle non utilise
            if(!balles[i].used){
                non_used=i;i=10;
            }
        }
        if(non_used>=0){//si on en trouve une, on l'utilise pour tirer
            balles[non_used].posx=(((4<<8)*PA_Cos(angle))>>8)+hero.posx+(8<<8);
            balles[non_used].posy=(((4<<8)*PA_Sin(angle))>>8)+hero.posy+(8<<8);
            balles[non_used].movx=-((arme[weapon].vitesse)*PA_Cos(angle))>>8;
            balles[non_used].movy=((arme[weapon].vitesse)*PA_Sin(angle))>>8;
            balles[non_used].used=1;
            balles[non_used].parcouru=0;
        }
    }else{
        int angle2=angle+6;//on dcale l'angle de tir (fusil  pompe)
        for(j=0;j<5;j++){//on va tirer 5 bales
            for(i=0;i<10;i++){//on cherche une balle libre
                if(!balles[i].used) {non_used=i;i=10;}
            }
            if(non_used>=0){//si trouv
                balles[non_used].posx=(((4<<8)*PA_Cos(angle))>>8)+hero.posx+(8<<8);
                balles[non_used].posy=(((4<<8)*PA_Sin(angle))>>8)+hero.posy+(8<<8);
                balles[non_used].movx=-((arme[weapon].vitesse)*PA_Cos(angle2))>>8;
                balles[non_used].movy=((arme[weapon].vitesse)*PA_Sin(angle2))>>8;
                balles[non_used].used=1;
                balles[non_used].parcouru=0;
                angle2-=3;//la balle suivante sera dcal
            }
        }
    }
    if(weapon>0){//si arme autre que pistolet, moins 1 munition
        arme[weapon].munitions--;
        if(arme[weapon].munitions==0) weapon=0;
        if(weapon>0) PA_OutputText(1,1,23,"%s : %d   ",nom_armes[weapon],arme[weapon].munitions);
        else PA_OutputText(1,1,23,"%s                    ",nom_armes[weapon]);
    }
}

void move_balles(){//bouger les projectiles
    u8 i,j;
    u8 toucher=0;
    //les balles vont tellement vites qu'on va dcomposer leurs mouvements 16 fois
    //entre deux points pour ne pas rater d'ennemis sur le passage
    for(j=0;j<16;j++){
        for(i=0;i<10;i++){
            if(balles[i].used){//si balle en jeu
                balles[i].parcouru++;//on note qu'elle a avanc
                balles[i].posx-=balles[i].movx>>4;
                balles[i].posy-=balles[i].movy>>4;
                if(balles[i].posx>=0&&balles[i].posx<(256<<8)&&balles[i].posy>=0&&balles[i].posy<(192<<8)){
                    //si balle dans l'cran, on dessine la traine
                    PA_Draw8bitLine (0, balles[i].posx>>8, balles[i].posy>>8, (balles[i].posx+(balles[i].movx>>4))>>8, (balles[i].posy+(balles[i].movy>>4))>>8, 1);
                }
                //on vrifie qu'elle touche quelqu'un ou pas
                toucher = verif_toucher(i);
                PA_SetSpriteXY(0,i,balles[i].posx>>8,balles[i].posy>>8);
            }
        }
    }
    //si on a touch quelqu'un : on efface les traines
    if(toucher==1) PA_Clear8bitBg(0);
}

void verif_touches(int angle){//vrification des pressions
    hero.posx+=hero.vitesse*(Pad.Held.Right-Pad.Held.Left);
    hero.posy+=hero.vitesse*(Pad.Held.Down-Pad.Held.Up);
    if((Pad.Held.L||Pad.Held.R)&&cool>=arme[weapon].cooltime&&(arme[weapon].munitions>0||arme[weapon].munitions==-1)){
        shoot(angle);
        cool=0;
    }
    if(Pad.Newpress.Select){//changement d'arme
        weapon++;
        if(weapon>2) weapon=0;
        while(arme[weapon].munitions==0){
            weapon++;
            if(weapon>2) weapon=0;
        }
        if(weapon>0) PA_OutputText(1,1,23,"%s : %d   ",nom_armes[weapon],arme[weapon].munitions);
        else PA_OutputText(1,1,23,"%s                ",nom_armes[weapon]);
    }
}

void new_ennemy(){//nouvelle ennemi
    u8 i;
    s8 non_used=-1;
    if(chef>0){
        for(i=0;i<10;i++){
            if(!ennemy[i].used) {non_used=i;i=10;}
        }
        if(non_used>=0){
            ennemy[non_used].posx=(PA_RandMinMax(10,240))<<8;
            ennemy[non_used].posy=(PA_RandMinMax(10,170))<<8;
            ennemy[non_used].used=1;
            ennemy[non_used].vie=100;
        }
    }else{
        for(i=10;i<15;i++){
            if(!ennemy[i].used) {non_used=i;i=15;}
        }
        if(non_used>=0){
            ennemy[non_used].posx=(PA_RandMinMax(10,240))<<8;
            ennemy[non_used].posy=(PA_RandMinMax(10,170))<<8;
            ennemy[non_used].used=1;
            ennemy[non_used].vie=500;
        }
    }
}

void move_ennemy(){//mouvement ennemi
    int angle2;
    u8 i;
    for(i=0;i<15;i++){
        if(ennemy[i].used){
            angle2=PA_GetAngle((hero.posx>>8)+4,(hero.posy>>8)+4,(ennemy[i].posx>>8)+4,(ennemy[i].posy>>8)+4);
            ennemy[i].movx=((ennemy[i].vitesse)*PA_Cos(angle2))>>8;
            ennemy[i].movy=((ennemy[i].vitesse)*PA_Sin(angle2))>>8;
            ennemy[i].posx-=ennemy[i].movx;
            ennemy[i].posy+=ennemy[i].movy;
            PA_SetSpriteXY(0,i+20,ennemy[i].posx>>8,ennemy[i].posy>>8);
            PA_SetRotsetNoZoom(0,i+1,angle2-256);
        }
    }
}

u8 verif_toucher(u8 i){//vrification de collision entre balle et ennemi
    u8 j;
    if(balles[i].posx<0||balles[i].posx>256<<8||balles[i].posy<0||balles[i].posy>192<<8){
        PA_Clear8bitBg(0);
        balles[i].used=0;
    }
    else if(balles[i].parcouru>=arme[weapon].range){
        PA_Clear8bitBg(0);
        balles[i].used=0;
    }
    else{
        for(j=0;j<15;j++){
            if(ennemy[j].used){
                if(collision(i,j)){
                    balles[i].used=0;
                    balles[i].posx=256<<8;
                    balles[i].posy=192<<8;
                    ennemy[j].posx+=ennemy[j].movx*25;
                    ennemy[j].posy-=ennemy[j].movy*25;
                    if(ennemy[j].posx<0) ennemy[j].posx=0;
                    else if(ennemy[j].posx>240<<8) ennemy[j].posx=240<<8;
                    else if(ennemy[j].posy<0) ennemy[j].posy=0;
                    else if(ennemy[j].posy>176<<8) ennemy[j].posx=176<<8;
                    ennemy[j].vie-=arme[weapon].degats;
                    if(ennemy[j].vie<=0)
                    {
                        if(j>=10) lacher_bonus(j);
                        ennemy[j].posx=256<<8;
                        ennemy[j].posy=192<<8;
                        ennemy[j].used=0;
                        score+=combo*100;
                        PA_OutputText(1,6,14,"score : %d",score);
                        combo++;
                        //ennemy_time=240-(vague*10);
                        time_combo=300-(combo*4);
                        if(combo>debloque)
                        {
                            debloque=combo;
                            unlock();
                        }
                    }
                    PA_SetSpriteXY(0,j+20,ennemy[j].posx>>8,ennemy[j].posy>>8);
                    return 1;
                }
            }
        }
    }
    return 0;
}

int collision(u8 ball, u8 ennemy_){
    if(balles[ball].posx>=ennemy[ennemy_].posx
        &&balles[ball].posx<ennemy[ennemy_].posx+(16<<8)
            &&balles[ball].posy>=ennemy[ennemy_].posy
                &&balles[ball].posy<ennemy[ennemy_].posy+(16<<8)) return 1;
    else return 0;

}

void touche_bonus(){
    u8 i,j,ok=0;
    int oldx=Stylus.X;
    int oldy=Stylus.Y;
    for(i=0;i<5;i++){
        if(bonuss[i].used){
            bonuss[i].time++;
            if( bonuss[i].time>=600){
                bonuss[i].used=0;
                PA_SetSpriteXY(0,40+i,256,192);
            }else{
                Stylus.X=(hero.posx>>8)+8;
                Stylus.Y=(hero.posy>>8)+8;
                if(PA_SpriteTouched(i+40)){
                    bonuss[i].used=0;
                    PA_SetSpriteXY(0,40+i,256,192);
                    for(j=0;j<arme_ok;j++){
                        if(arme[j].munitions==0){
                            arme[j].munitions=arme[j].muni_max;
                            j=arme_ok;
                            ok=1;
                        }
                    }
                    if(!ok) arme[weapon].munitions=arme[weapon].muni_max;
                }
            }
            Stylus.X=oldx;
            Stylus.Y=oldy;
        }
    }
}

void gestion_combo(){
    if(time_combo>0) time_combo--;
    else if(time_combo==0&&combo>0)
    {
        combo--;
        time_combo=300-(combo*3);
    }
    ennemy_time=260-(vague*20);
    PA_OutputText(1,1,20,"combo : %d time : %d    ",combo,time_combo);
}

void unlock(){
    if(debloque==3) arme[0].cooltime-=5;
    else if(debloque==5) {arme[1].munitions=arme[1].muni_max;arme_ok++;}
    else if(debloque==8) arme[0].range+=50;
    else if(debloque==9) arme[1].cooltime-=5;
    else if(debloque==10) {arme[2].munitions=arme[2].muni_max;arme_ok++;}
    else if(debloque==13) arme[1].muni_max+=100;
    else if(debloque==15) arme[2].muni_max+=20;
    else if(debloque==17) arme[0].cooltime-=5;
    else if(debloque==18) arme[2].cooltime-=30;
}

void nouvelle_vague(){
    u8 i;
    u16 angle=0;
    for(i=0;i<180;i++){
        angle=PA_GetAngle((hero.posx>>8)+4,(hero.posy>>8)+5,Stylus.X,Stylus.Y);
        PA_SetRotsetNoZoom(0,0,angle);
        verif_touches(angle);
        move_balles();
        touche_bonus();
        PA_SetSpriteXY(0,10,hero.posx>>8,hero.posy>>8);
        PA_WaitForVBL();
    }
    vague++;
    limite+=5;
    nb_ennemy=-(vague*2);
    if(nb_ennemy<-10) nb_ennemy=-10;
    chef=900;
    PA_OutputText(0,10,0,"vague %d",vague);
    for(i=0;i<vague*2;i++){
        new_ennemy();
    }
    for(i=0;i<180;i++){
        angle=PA_GetAngle((hero.posx>>8)+4,(hero.posy>>8)+5,Stylus.X,Stylus.Y);
        PA_SetRotsetNoZoom(0,0,angle);
        verif_touches(angle);
        move_balles();
        touche_bonus();
        PA_SetSpriteXY(0,10,hero.posx>>8,hero.posy>>8);
        PA_WaitForVBL();
    }
    PA_OutputText(0,10,0,"             ");
}

int aucun_ennemy(){
    u8 i;
    for(i=0;i<15;i++){
        if(ennemy[i].used==1) return 0;
    }
    return 1;
}

void lacher_bonus(u8 j){
    u8 k;
    s8 used=-1;
    for(k=0;k<5;k++){
        if(!bonuss[k].used) {used=k;k=5;}
    }
    if(used>=0){
        bonuss[used].posx=ennemy[j].posx+(8<<8);
        bonuss[used].posy=ennemy[j].posy+(8<<8);
        PA_SetSpriteXY(0,used+40,bonuss[used].posx>>8,bonuss[used].posy>>8);
        bonuss[used].used=1;
        bonuss[used].time=0;
    }
}
